From c547547b0305af5e01b1bae39fa0613e5f527984 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 27 2021 05:23:04 +0000
Subject: [PATCH 2222/2232] Add ui test of impls on a nonlocal Rust type


---

diff --git a/tests/ui/nonlocal_rust_type.rs b/tests/ui/nonlocal_rust_type.rs
new file mode 100644
index 0000000..d8a238a
--- /dev/null
+++ b/tests/ui/nonlocal_rust_type.rs
@@ -0,0 +1,18 @@
+pub struct MyBuilder<'a> {
+    _s: &'a str,
+}
+
+type OptBuilder<'a> = Option<MyBuilder<'a>>;
+
+#[cxx::bridge]
+mod ffi {
+    extern "Rust" {
+        type OptBuilder<'a>;
+    }
+
+    struct MyBuilder<'a> {
+        rs: Box<OptBuilder<'a>>,
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/nonlocal_rust_type.stderr b/tests/ui/nonlocal_rust_type.stderr
new file mode 100644
index 0000000..584090a
--- /dev/null
+++ b/tests/ui/nonlocal_rust_type.stderr
@@ -0,0 +1,27 @@
+error[E0117]: only traits defined in the current crate can be implemented for arbitrary types
+  --> $DIR/nonlocal_rust_type.rs:10:9
+   |
+10 |         type OptBuilder<'a>;
+   |         ^^^^^--------------
+   |         |    |
+   |         |    `Option` is not defined in the current crate
+   |         impl doesn't use only types from inside the current crate
+   |
+   = note: define and implement a trait or new type instead
+
+error[E0117]: only traits defined in the current crate can be implemented for arbitrary types
+  --> $DIR/nonlocal_rust_type.rs:7:1
+   |
+7  |   #[cxx::bridge]
+   |   ^^^^^^^^^^^^^^ impl doesn't use only types from inside the current crate
+...
+10 |           type OptBuilder<'a>;
+   |  ___________________________-
+11 | |     }
+12 | |
+13 | |     struct MyBuilder<'a> {
+14 | |         rs: Box<OptBuilder<'a>>,
+   | |__________________________- `Option` is not defined in the current crate
+   |
+   = note: define and implement a trait or new type instead
+   = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)

